//---------------------------------------------------------------------------
#pragma hdrstop
#include "Interface.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
// Constructor TInterface  public
__fastcall TInterface::TInterface()
{
        Created = false;
        hINTERFACE = NULL;
}
//---------------------------------------------------------------------------
// Destructor TInterface  public
__fastcall TInterface::~TInterface()
{
        if (Created == true) Close();
}
//---------------------------------------------------------------------------
// Create PIPE to Device public
INT_STATUS __fastcall TInterface::Create(LPINTPARAMETERS pINT_Parameters)
{
        if (Created) Close();
        Parameters = *pINT_Parameters;
        switch (Parameters.Mode) {
                case INT_RS:
                        hINTERFACE = CreateFile(Parameters.lpszName, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
                        if ((hINTERFACE != INVALID_HANDLE_VALUE) && (hINTERFACE != NULL)) {
                                GetCommState(hINTERFACE, (LPDCB)&INT_DCB);
                                INT_DCB.DCBlength = sizeof(INT_DCB);
                                INT_DCB.BaudRate = Parameters.BaudRate;
                                INT_DCB.ByteSize = 8;
                                switch (Parameters.Parity) {
                                        case INT_NO_PARITY:
                                                INT_DCB.Parity = NOPARITY;
                                                INT_DCB.fParity = 0;
                                        break;
                                        case INT_ODD_PARITY:
                                                INT_DCB.Parity = ODDPARITY;
                                                INT_DCB.fParity = 1;
                                        break;
                                        case INT_EVEN_PARITY:
                                                INT_DCB.Parity = EVENPARITY;
                                                INT_DCB.fParity = 1;
                                        break;
                                }
                                switch (Parameters.StopBits) {
                                        case INT_1_STOP_BITS:   INT_DCB.StopBits = ONESTOPBIT;    break;
                                        case INT_1_5_STOP_BITS: INT_DCB.StopBits = ONE5STOPBITS;  break;
                                        case INT_2_STOP_BITS:   INT_DCB.StopBits = TWOSTOPBITS;   break;
                                }
                                INT_DCB.fBinary = 1;
                                INT_DCB.fOutxCtsFlow = 0;
                                INT_DCB.fOutxDsrFlow = 0;
                                INT_DCB.fDtrControl = DTR_CONTROL_ENABLE;
                                INT_DCB.fDsrSensitivity = 0;
                                INT_DCB.fTXContinueOnXoff = 0;
                                INT_DCB.fOutX = 0;
                                INT_DCB.fInX = 0;
                                INT_DCB.fErrorChar = 0;
                                INT_DCB.fNull = 0;
                                INT_DCB.fRtsControl = RTS_CONTROL_ENABLE;
                                INT_DCB.fAbortOnError = 0;
                                SetCommState(hINTERFACE, (LPDCB)&INT_DCB);
                                TIMEOUTS.ReadIntervalTimeout = Parameters.dwTimeOutByte;
                                TIMEOUTS.ReadTotalTimeoutMultiplier = Parameters.dwTimeOutByte;
                                TIMEOUTS.ReadTotalTimeoutConstant = Parameters.dwTimeOutTotal;
                                TIMEOUTS.WriteTotalTimeoutMultiplier = 0;
                                TIMEOUTS.WriteTotalTimeoutConstant = 0;
                                SetCommTimeouts(hINTERFACE, (LPCOMMTIMEOUTS)&TIMEOUTS);
                                SetupComm(hINTERFACE, Parameters.dwBufferIn, Parameters.dwBufferOut);
                                PurgeComm(hINTERFACE, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
                                SetCommMask(hINTERFACE, EV_RXCHAR | EV_TXEMPTY);
                                Created = true;
                                Status = INT_OK;
                        } else {
                                Status = INT_DEVICE_NOT_OPENNED;
                                hINTERFACE = NULL;
                        }
                break;
                case INT_USB_RS:
                        hINTERFACE = FT_W32_CreateFile(Parameters.lpszName, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, Parameters.dwFlagsAndAttributes | FT_OPEN_BY_DESCRIPTION, NULL);
                        if ((hINTERFACE != INVALID_HANDLE_VALUE) && (hINTERFACE != NULL)) {
                                FT_W32_GetCommState(hINTERFACE, (LPFTDCB)&INT_DCB);
                                INT_DCB.DCBlength = sizeof(INT_DCB);
                                INT_DCB.BaudRate = Parameters.BaudRate;
                                INT_DCB.ByteSize = 8;
                                switch (Parameters.Parity) {
                                        case INT_NO_PARITY:
                                                INT_DCB.Parity = FT_PARITY_NONE;
                                                INT_DCB.fParity = 0;
                                        break;
                                        case INT_ODD_PARITY:
                                                INT_DCB.Parity = FT_PARITY_ODD;
                                                INT_DCB.fParity = 1;
                                        break;
                                        case INT_EVEN_PARITY:
                                                INT_DCB.Parity = FT_PARITY_EVEN;
                                                INT_DCB.fParity = 1;
                                        break;
                                }
                                switch (Parameters.StopBits) {
                                        case INT_1_STOP_BITS:   INT_DCB.StopBits = FT_STOP_BITS_1;    break;
                                        case INT_1_5_STOP_BITS: INT_DCB.StopBits = FT_STOP_BITS_1_5;  break;
                                        case INT_2_STOP_BITS:   INT_DCB.StopBits = FT_STOP_BITS_2;    break;
                                }
                                INT_DCB.fBinary = 1;
                                INT_DCB.fOutxCtsFlow = 0;
                                INT_DCB.fOutxDsrFlow = 0;
                                INT_DCB.fDtrControl = DTR_CONTROL_DISABLE;
                                INT_DCB.fDsrSensitivity = 0;
                                INT_DCB.fTXContinueOnXoff = 0;
                                INT_DCB.fOutX = 0;
                                INT_DCB.fInX = 0;
                                INT_DCB.fErrorChar = 0;
                                INT_DCB.fNull = 0;
                                INT_DCB.fRtsControl = RTS_CONTROL_DISABLE;
                                INT_DCB.fAbortOnError = 0;
                                FT_W32_SetCommState(hINTERFACE, (LPFTDCB)&INT_DCB);
                                TIMEOUTS.ReadIntervalTimeout = Parameters.dwTimeOutByte;
                                TIMEOUTS.ReadTotalTimeoutMultiplier = Parameters.dwTimeOutByte;
                                TIMEOUTS.ReadTotalTimeoutConstant = Parameters.dwTimeOutTotal;
                                TIMEOUTS.WriteTotalTimeoutMultiplier = 0;
                                TIMEOUTS.WriteTotalTimeoutConstant = 0;
                                FT_W32_SetCommTimeouts(hINTERFACE, (LPFTTIMEOUTS)&TIMEOUTS);
                                FT_W32_SetupComm(hINTERFACE, Parameters.dwBufferIn, Parameters.dwBufferOut);
                                FT_W32_PurgeComm(hINTERFACE, FT_PURGE_RX | FT_PURGE_TX);
                                FT_W32_SetCommMask(hINTERFACE, EV_RXCHAR | EV_TXEMPTY);
                                Created = true;
                                Status = INT_OK;
                        } else Status = INT_DEVICE_NOT_OPENNED;
                        if (Status != INT_OK) hINTERFACE = NULL;
                break;
        }
        return (Status);
}
//---------------------------------------------------------------------------
INT_STATUS __fastcall TInterface::INT_SetBaurRate(LPDWORD lpBaudRate)
{
        if (Created) {
                switch (Parameters.Mode) {
                        case INT_RS:
                                GetCommState(hINTERFACE, (LPDCB)&INT_DCB);
                                INT_DCB.BaudRate = *lpBaudRate;
                                Parameters.BaudRate = *lpBaudRate;
                                SetCommState(hINTERFACE, (LPDCB)&INT_DCB);
                        break;
                        case INT_USB_RS:
                                FT_W32_GetCommState(hINTERFACE, (LPFTDCB)&INT_DCB);
                                INT_DCB.BaudRate = *lpBaudRate;
                                Parameters.BaudRate = *lpBaudRate;
                                FT_W32_SetCommState(hINTERFACE, (LPFTDCB)&INT_DCB);
                        break;
                }
                Status = INT_OK;
        } else Status = INT_DEVICE_NOT_OPENNED;
        return (Status);
}
//---------------------------------------------------------------------------
// Close PIPE to Device public
INT_STATUS __fastcall TInterface::Close()
{
        if (Created) {
                switch (Parameters.Mode) {
                        case INT_RS:
                                if ((hINTERFACE != NULL) && (hINTERFACE != INVALID_HANDLE_VALUE)) {
                                        EscapeCommFunction(hINTERFACE, SETBREAK);
                                        CloseHandle(hINTERFACE);
                                }
                                hINTERFACE = NULL;
                        break;
                        case INT_USB_RS:
                                if ((hINTERFACE != NULL) && (hINTERFACE != INVALID_HANDLE_VALUE)) {
                                        FT_SetBreakOn(hINTERFACE);
                                        FT_W32_CloseHandle(hINTERFACE);
                                }
                                hINTERFACE = NULL;
                        break;
                }
        }
        Created = false;
        Status = INT_OK;
        return (Status);
}
//---------------------------------------------------------------------------
// Write to PIPE public
INT_STATUS __fastcall TInterface::INT_ReadFile(LPINTREAD pINT_Read)
{
        DWORD dwnRead;
        if (Created) {
                switch (Parameters.Mode) {
                        case INT_RS:
                                if (ReadFile(hINTERFACE, pINT_Read->pBuffer, pINT_Read->nNumberOfBytesToRead, &dwnRead, NULL)) {
                                        if (pINT_Read->nNumberOfBytesToRead != dwnRead) {
                                                pINT_Read->nNumberOfBytesToRead -= dwnRead;
                                                if (ReadFile(hINTERFACE, (void *)((char *)pINT_Read->pBuffer + dwnRead), pINT_Read->nNumberOfBytesToRead, &dwnRead, NULL)) {
                                                        if (pINT_Read->nNumberOfBytesToRead != dwnRead) {
                                                                pINT_Read->nNumberOfBytesToRead -= dwnRead;
                                                                if (ReadFile(hINTERFACE, (void *)((char *)pINT_Read->pBuffer + dwnRead), pINT_Read->nNumberOfBytesToRead, &dwnRead, NULL)) {
                                                                        if (pINT_Read->nNumberOfBytesToRead != dwnRead) {
                                                                                Status = INT_DEVICE_READ_TIMEOUT;
                                                                        }
                                                                        else Status = INT_OK;
                                                                }
                                                        }
                                                        else Status = INT_OK;
                                                }
                                        }
                                        else Status = INT_OK;
                                } else Status = INT_DEVICE_READ_ERROR;
                        break;
                        case INT_USB_RS:
                                if (FT_W32_ReadFile(hINTERFACE, pINT_Read->pBuffer, pINT_Read->nNumberOfBytesToRead, &dwnRead, 0)) {
                                        if (pINT_Read->nNumberOfBytesToRead != dwnRead) Status = INT_DEVICE_READ_TIMEOUT;
                                        else Status = INT_OK;
                                } else Status = INT_DEVICE_READ_ERROR;
                        break;
                }
        } else Status = INT_DEVICE_NOT_OPENNED;
        return (Status);
}
//---------------------------------------------------------------------------
// Read from PIPE public
INT_STATUS __fastcall TInterface::INT_WriteFile(LPINTWRITE pINT_Write)
{
        DWORD dwnWritten;
        if (Created) {
                switch (Parameters.Mode) {
                        case INT_RS:
                                PurgeComm(hINTERFACE, PURGE_TXCLEAR | PURGE_RXCLEAR);
                                if (WriteFile(hINTERFACE, pINT_Write->pBuffer, pINT_Write->nNumberOfBytesToWrite, &dwnWritten, pINT_Write->lpOverlapped)) {
                                        if (pINT_Write->nNumberOfBytesToWrite != dwnWritten) Status = INT_DEVICE_WRITE_TIMEOUT;
                                        else Status = INT_OK;
                                } else Status = INT_DEVICE_WRITE_ERROR;
                        break;
                        case INT_USB_RS:
                                FT_W32_PurgeComm(hINTERFACE, FT_PURGE_RX | FT_PURGE_TX);
                                if (FT_W32_WriteFile(hINTERFACE, pINT_Write->pBuffer, pINT_Write->nNumberOfBytesToWrite, &dwnWritten, pINT_Write->lpOverlapped)) {
                                       if (pINT_Write->nNumberOfBytesToWrite != dwnWritten) Status = INT_DEVICE_WRITE_TIMEOUT;
                                       else Status = INT_OK;
                                } else Status = INT_DEVICE_WRITE_ERROR;
                        break;
                }
        } else Status = INT_DEVICE_NOT_OPENNED;
        return (Status);
}
//---------------------------------------------------------------------------
