//---------------------------------------------------------------------------
#ifndef _InterfaceH_
        #define _InterfaceH_
//---------------------------------------------------------------------------
        #include "Windows.h"
        #pragma link "FTD2XX.lib"
        #include "FTD2XX.h"
//---------------------------------------------------------------------------
        #ifndef _Interface_types_
                #define _Interface_types_
                typedef PVOID INT_HANDLE;
                typedef BYTE INT_MODE;
                typedef LPBYTE LPINT_MODE;
                typedef BYTE INT_STOP_BITS;
                typedef LPBYTE LPINT_STOP_BITS;
                typedef BYTE INT_PARITY;
                typedef LPBYTE LPINT_PARITY;
                typedef ULONG INT_STATUS;
                typedef struct _INTCOMSTAT {
                        DWORD fCtsHold : 1;
                        DWORD fDsrHold : 1;
                        DWORD fRlsdHold : 1;
                        DWORD fXoffHold : 1;
                        DWORD fXoffSent : 1;
                        DWORD fEof : 1;
                        DWORD fTxim : 1;
                        DWORD fReserved : 25;
                        DWORD cbInQue;
                        DWORD cbOutQue;
                } INTCOMSTAT, *LPINTCOMSTAT;
                typedef struct _INTDCB {
                        DWORD DCBlength;
                        DWORD BaudRate;
                        DWORD fBinary: 1;
                        DWORD fParity: 1;
                        DWORD fOutxCtsFlow:1;
                        DWORD fOutxDsrFlow:1;
                        DWORD fDtrControl:2;
                        DWORD fDsrSensitivity:1;
                        DWORD fTXContinueOnXoff: 1;
                        DWORD fOutX: 1;
                        DWORD fInX: 1;
                        DWORD fErrorChar: 1;
                        DWORD fNull: 1;
                        DWORD fRtsControl:2;
                        DWORD fAbortOnError:1;
                        DWORD fDummy2:17;
                        WORD wReserved;
                        WORD XonLim;
                        WORD XoffLim;
                        BYTE ByteSize;
                        BYTE Parity;
                        BYTE StopBits;
                        char XonChar;
                        char XoffChar;
                        char ErrorChar;
                        char EofChar;
                        char EvtChar;
                        WORD wReserved1;
                } INTDCB, *LPINTDCB;
                typedef struct _INTTIMEOUTS {
                        DWORD ReadIntervalTimeout;
                        DWORD ReadTotalTimeoutMultiplier;
                        DWORD ReadTotalTimeoutConstant;
                        DWORD WriteTotalTimeoutMultiplier;
                        DWORD WriteTotalTimeoutConstant;
                } INTTIMEOUTS, *LPINTTIMEOUTS;
                typedef struct _INTPARAMETERS {
                        INT_MODE Mode;
                        LPCTSTR lpszName;
                        INT_STOP_BITS StopBits;
                        INT_PARITY Parity;
                        DWORD BaudRate;
                        DWORD dwFlagsAndAttributes;
                        DWORD dwBufferIn;
                        DWORD dwBufferOut;
                        DWORD dwTimeOutByte;
                        DWORD dwTimeOutTotal;
                } INTPARAMETERS, *LPINTPARAMETERS;
                typedef struct _INTREAD {
                        LPVOID pBuffer;
                        DWORD nNumberOfBytesToRead;
                        LPOVERLAPPED lpOverlapped;
                } INTREAD, *LPINTREAD;
                typedef struct _INTWRITE {
                        LPVOID pBuffer;
                        DWORD nNumberOfBytesToWrite;
                        LPOVERLAPPED lpOverlapped;
                } INTWRITE, *LPINTWRITE;
                enum {
                        INT_OK,
                        INT_DEVICE_NOT_FOUND,
                        INT_DEVICE_NOT_OPENNED,
                        INT_DEVICE_READ_TIMEOUT,
                        INT_DEVICE_READ_ERROR,
                        INT_DEVICE_WRITE_TIMEOUT,
                        INT_DEVICE_WRITE_ERROR,
                        INT_DEVICE_OTHER_ERROR
                };
                enum {
                        INT_RS,
                        INT_USB_RS,
                };
                enum {
                        INT_1_STOP_BITS,
                        INT_1_5_STOP_BITS,
                        INT_2_STOP_BITS
                };
                enum {
                        INT_NO_PARITY,
                        INT_ODD_PARITY,
                        INT_EVEN_PARITY
                };
         #endif
//---------------------------------------------------------------------------
        class TInterface {
                private:
                        bool Created;
                        INT_HANDLE hINTERFACE;
                        INTCOMSTAT COMSTAT;
                        INTDCB INT_DCB;
                        INTTIMEOUTS TIMEOUTS;
                        INT_STATUS Status;
                        INTPARAMETERS Parameters;
                public:
                        INT_STATUS __fastcall Create(LPINTPARAMETERS pINT_Parameters);
                        INT_STATUS __fastcall INT_SetBaurRate(LPDWORD lpBaudRate);                        
                        INT_STATUS __fastcall Close();
                        INT_STATUS __fastcall INT_ReadFile(LPINTREAD pINT_Read);
                        INT_STATUS __fastcall INT_WriteFile(LPINTWRITE pINT_Write);
                        __fastcall TInterface();
                        __fastcall ~TInterface();
        };
//---------------------------------------------------------------------------
#endif



