//---------------------------------------------------------------------------
#pragma hdrstop
#include "MotorInterface.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
MOTPARAMETERS Motor_PARAMETERS_DEF = {
                        0x0007, 0x0032, 0x0800
                };
BYTE Motor_PARAMETERS_LEN[con_MOTOR_REGISTERS] = {
                        1, 1, 2
                };
//---------------------------------------------------------------------------
__fastcall TMotorInterface::TMotorInterface()
{
        pInterface = new TInterface;
}
//---------------------------------------------------------------------------
__fastcall TMotorInterface::~TMotorInterface()
{
        delete pInterface;
}
//---------------------------------------------------------------------------
MOTORINT_STATUS __fastcall TMotorInterface::Connect(LPMOTORINTPARAMETERS pMOTORINT_Parameters)
{
        Parameters = *pMOTORINT_Parameters;
        INT_Parameters.Mode = Parameters.Mode;
        INT_Parameters.lpszName = Parameters.lpszName;
        INT_Parameters.StopBits = INT_1_STOP_BITS;
        INT_Parameters.Parity = INT_NO_PARITY;
        INT_Parameters.BaudRate = Parameters.BaudRate;
        INT_Parameters.dwFlagsAndAttributes = FILE_ATTRIBUTE_NORMAL;
        INT_Parameters.dwBufferIn = 16;
        INT_Parameters.dwBufferOut = 16;
        INT_Parameters.dwTimeOutByte = 10;
        INT_Parameters.dwTimeOutTotal = 1000;
        Status = pInterface->Create(&INT_Parameters);
        return(Status);
}
//---------------------------------------------------------------------------
MOTORINT_STATUS __fastcall TMotorInterface::Disonnect()
{
        Status = pInterface->Close();
        return(Status);
}
//---------------------------------------------------------------------------
MOTORINT_STATUS __fastcall TMotorInterface::MotInit()
{
        BUFFER[0] = cm_MTInit;
        INT_Write.pBuffer = &BUFFER[0];
        INT_Write.nNumberOfBytesToWrite = 1;
        INT_Write.lpOverlapped = NULL;
        Status = pInterface->INT_WriteFile(&INT_Write);
        if (Status != MOTORINT_OK) return(Status);
        INT_Read.pBuffer = &BUFFER[0];
        INT_Read.nNumberOfBytesToRead = 2;
        INT_Read.lpOverlapped = NULL;
        Status = pInterface->INT_ReadFile(&INT_Read);
        if (Status != MOTORINT_OK) return(Status);
        return(Status);
}
//---------------------------------------------------------------------------
MOTORINT_STATUS __fastcall TMotorInterface::MotGoFw(DWORD Steps)
{
        BUFFER[0] = cm_MTMvFW;
        BUFFER[1] = ((Steps >> 0)&0x0F) | 0xF0;
        BUFFER[2] = ((Steps >> 4)&0x0F) | 0xF0;
        BUFFER[3] = ((Steps >> 8)&0x0F) | 0xF0;
        BUFFER[4] = ((Steps >> 12)&0x0F) | 0xF0;
        BUFFER[5] = ((Steps >> 16)&0x0F) | 0xF0;
        BUFFER[6] = ((Steps >> 20)&0x0F) | 0xF0;
        BUFFER[7] = ((Steps >> 24)&0x0F) | 0xF0;
        BUFFER[8] = ((Steps >> 28)&0x0F) | 0xF0;
        for (BYTE i = 0; i < 9; i++) {
                INT_Write.pBuffer = &BUFFER[i];
                INT_Write.nNumberOfBytesToWrite = 1;
                INT_Write.lpOverlapped = NULL;
                Status = pInterface->INT_WriteFile(&INT_Write);
                if (Status != MOTORINT_OK) return(Status);
        }
        INT_Read.pBuffer = &BUFFER[0];
        INT_Read.nNumberOfBytesToRead = 6;
        INT_Read.lpOverlapped = NULL;
        Status = pInterface->INT_ReadFile(&INT_Read);
        if (Status != MOTORINT_OK) return(Status);
        MOTOR_SYSW = ((BUFFER[0] & 0x0F) | ((BUFFER[1] << 4) & 0xF0));
//        *lpMOTOR_SYSW = MOTOR_SYSW;
        return(Status);
}
//---------------------------------------------------------------------------
MOTORINT_STATUS __fastcall TMotorInterface::MotGoBw(DWORD Steps)
{
        BUFFER[0] = cm_MTMvBW;
        BUFFER[1] = ((Steps >> 0)&0x0F) | 0xF0;
        BUFFER[2] = ((Steps >> 4)&0x0F) | 0xF0;
        BUFFER[3] = ((Steps >> 8)&0x0F) | 0xF0;
        BUFFER[4] = ((Steps >> 12)&0x0F) | 0xF0;
        BUFFER[5] = ((Steps >> 16)&0x0F) | 0xF0;
        BUFFER[6] = ((Steps >> 20)&0x0F) | 0xF0;
        BUFFER[7] = ((Steps >> 24)&0x0F) | 0xF0;
        BUFFER[8] = ((Steps >> 28)&0x0F) | 0xF0;
        for (BYTE i = 0; i < 9; i++) {
                INT_Write.pBuffer = &BUFFER[i];
                INT_Write.nNumberOfBytesToWrite = 1;
                INT_Write.lpOverlapped = NULL;
                Status = pInterface->INT_WriteFile(&INT_Write);
                if (Status != MOTORINT_OK) return(Status);
        }
        INT_Read.pBuffer = &BUFFER[0];
        INT_Read.nNumberOfBytesToRead = 6;
        INT_Read.lpOverlapped = NULL;
        Status = pInterface->INT_ReadFile(&INT_Read);
        if (Status != MOTORINT_OK) return(Status);
        MOTOR_SYSW = ((BUFFER[0] & 0x0F) | ((BUFFER[1] << 4) & 0xF0));
//        *lpMOTOR_SYSW = MOTOR_SYSW;
        return(Status);
}
//---------------------------------------------------------------------------
MOTORINT_STATUS __fastcall TMotorInterface::MotStop(LPBYTE lpMOTOR_SYSW)
{
        BUFFER[0] = cm_MTStop;
        INT_Write.pBuffer = &BUFFER[0];
        INT_Write.nNumberOfBytesToWrite = 1;
        INT_Write.lpOverlapped = NULL;
        Status = pInterface->INT_WriteFile(&INT_Write);
        if (Status != MOTORINT_OK) return(Status);
        INT_Read.pBuffer = &BUFFER[0];
        INT_Read.nNumberOfBytesToRead = 6;
        INT_Read.lpOverlapped = NULL;
        Status = pInterface->INT_ReadFile(&INT_Read);
        if (Status != MOTORINT_OK) return(Status);
        MOTOR_SYSW = ((BUFFER[0] & 0x0F) | ((BUFFER[1] << 4) & 0xF0));
        *lpMOTOR_SYSW = MOTOR_SYSW;
        return(Status);
}
//---------------------------------------------------------------------------
MOTORINT_STATUS __fastcall TMotorInterface::GetSys(LPBYTE lpMOTOR_SYSW)
{
        BUFFER[0] = cm_MTGetSys;
        INT_Write.pBuffer = &BUFFER[0];
        INT_Write.nNumberOfBytesToWrite = 1;
        INT_Write.lpOverlapped = NULL;
        Status = pInterface->INT_WriteFile(&INT_Write);
        if (Status != MOTORINT_OK) return(Status);
        INT_Read.pBuffer = &BUFFER[0];
        INT_Read.nNumberOfBytesToRead = 6;
        INT_Read.lpOverlapped = NULL;
        Status = pInterface->INT_ReadFile(&INT_Read);
        if (Status != MOTORINT_OK) return(Status);
        MOTOR_SYSW = ((BUFFER[0] & 0x0F) | ((BUFFER[1] << 4) & 0xF0));
        *lpMOTOR_SYSW = MOTOR_SYSW;
        return(Status);
}
//---------------------------------------------------------------------------
MOTORINT_STATUS __fastcall TMotorInterface::InitParams()
{
        BYTE num_Param, ind_Param, len_Param;
        WORD Value_Param;
        Motor_PARAMETERS = Motor_PARAMETERS_DEF;
        for (num_Param = 0; num_Param < con_MOTOR_REGISTERS; num_Param ++) {
                len_Param = Motor_PARAMETERS_LEN[num_Param];
                BUFFER[0] = (cm_MTWrReg | num_Param) & 0x7F;
                Value_Param = Motor_PARAMETERS.RG_MAP[num_Param];
                for (ind_Param = 0; ind_Param < 2 * len_Param; ind_Param ++)
                        BUFFER[1 + ind_Param] = ((Value_Param >> (4 * ind_Param)) & 0x0F) | 0xF0;
                for (BYTE i = 0; i < (1 + 2 * len_Param); i++) {
                        INT_Write.pBuffer = &BUFFER[i];
                        INT_Write.nNumberOfBytesToWrite = 1;
                        INT_Write.lpOverlapped = NULL;
                        Status = pInterface->INT_WriteFile(&INT_Write);
                        if (Status != MOTORINT_OK) return(Status);
                }
                INT_Read.pBuffer = &BUFFER[0];
                INT_Read.nNumberOfBytesToRead = len_Param;
                INT_Read.lpOverlapped = NULL;
                Status = pInterface->INT_ReadFile(&INT_Read);
                if (Status != MOTORINT_OK) return(Status);
        }
        return(Status);
}
//---------------------------------------------------------------------------
