//---------------------------------------------------------------------------
#define MotorH
#ifndef _MotorH_
        #define _MotorH_
        #include "Interface.h"
//---------------------------------------------------------------------------
        #ifndef _Motor_types_
                #define _Motor_types_
                typedef ULONG MOTORINT_STATUS;
                typedef BYTE MOTORCommand;
                typedef LPBYTE lpMOTORCommand;
                typedef struct _MOTORINTPARAMETERS {
                        INT_MODE Mode;
                        LPCTSTR lpszName;
                        DWORD BaudRate;
                } MOTORINTPARAMETERS, *LPMOTORINTPARAMETERS;

                #define con_MOTOR_dX0_mm        250
                #define con_MOTOR_dX0_steps     20000
                #define con_MOTOR_step_um       ((float)con_MOTOR_dX0_mm * 1000 / (float)con_MOTOR_dX0_steps)

                #define cm_MTGetSys             0x00
                #define cm_MTRdReg              0x01
                #define cm_MTWrReg              0x02
                #define cm_MTInit               0x03
                #define cm_MTMvFW               0x04
                #define cm_MTMvBW               0x05
                #define cm_MTStop               0x06

                #define b_MT_Mv_Fw              0x01
                #define b_MT_Mv_Bw              0x02
                #define b_MT_Acc                0x04
                #define b_MT_Hold               0x08
                #define b_MT_Pos_B              0x10
                #define b_MT_Pos_E              0x20
                #define b_MT_TS_0               0x40
                #define b_MT_TS_1               0x80

                #define con_PM_SYSW             0
                #define con_PM_ACCSTEP          (con_PM_SYSW + 1)
                #define con_PM_ACCTIME          (con_PM_ACCSTEP + 1)
                #define con_MOTOR_REGISTERS     (con_PM_ACCTIME + 1)
                typedef union _MOTPARAMETERS{
                        WORD RG_MAP[con_MOTOR_REGISTERS];
                        struct{
                                union{
                                        WORD REG_VALUE;
                                        struct{
                                                WORD ACCON : 1;
                                                WORD CURR  : 1;
                                                WORD HOLD  : 1;
                                                WORD MICRO : 1;
                                                WORD MOVE  : 2;
                                                WORD HOLL  : 1;
                                                WORD INIT  : 1;
                                                WORD UNUSED: 8;
                                        } BIT;
                                } SYS;
                                WORD ACCSTEP;
                                WORD ACCTIME;
                        } REG_NAME;
                } MOTPARAMETERS, *LPMOTPARAMETERS;

                enum {
                        MOTORINT_OK,
                        MOTORINT_PORT_NOT_FOUND,
                        MOTORINT_PORT_NOT_OPENNED,
                        MOTORINT_READ_TIMEOUT,
                        MOTORINT_READ_ERROR,
                        MOTORINT_WRITE_TIMEOUT,
                        MOTORINT_WRITE_ERROR,
                        MOTORINT_OTHER_ERROR
                };
        #endif
//---------------------------------------------------------------------------
        class TMotorInterface {
                private:
                        BYTE BUFFER[16];
                        TInterface *pInterface;

                        MOTORINT_STATUS Status;
                        BYTE MOTOR_SYSW;
                        MOTORINTPARAMETERS Parameters;
                        INTPARAMETERS INT_Parameters;
                        INTWRITE INT_Write;
                        INTREAD INT_Read;
                        MOTPARAMETERS Motor_PARAMETERS;
                public:
                        __fastcall TMotorInterface();
                        __fastcall ~TMotorInterface();
                        MOTORINT_STATUS __fastcall Connect(LPMOTORINTPARAMETERS pMOTORINT_Parameters);
                        MOTORINT_STATUS __fastcall Disonnect();
                        MOTORINT_STATUS __fastcall MotInit();
                        MOTORINT_STATUS __fastcall MotGoFw(DWORD Steps);
                        MOTORINT_STATUS __fastcall MotGoBw(DWORD Steps);
                        MOTORINT_STATUS __fastcall MotStop(LPBYTE lpMOTOR_SYSW);
                        MOTORINT_STATUS __fastcall GetSys(LPBYTE lpMOTOR_SYSW);
                        MOTORINT_STATUS __fastcall InitParams();
        };
//---------------------------------------------------------------------------
#endif
