//---------------------------------------------------------------------------
#pragma hdrstop
#include "RF620Interface.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
BYTE PARAMS_LEN[con_FACTORY_REGISTERS] = {
                // Sensor Registers
		rl_SENSOR_SEQUENCER,    rl_SENSOR_NROF_PIXELS,  rl_SENSOR_NROF_LINES,     rl_SENSOR_INT_TIME,
                rl_SENSOR_X_REG,        rl_SENSOR_YL_REG,       rl_SENSOR_YR_REG,         rl_SENSOR_IMAGE_CORE,
                rl_SENSOR_AMPFILER,     rl_SENSOR_DACRAW_REG,   rl_SENSOR_DACFINE_REG,    rl_SENSOR_ADC_REG,
                // User Registers Default
                rl_USER_POWER,          rl_USER_ADDR,           rl_USER_RSBR,             rl_USER_RES_LEN,
                rl_USER_LAS_INT,        rl_USER_EXT_PORT,       rl_USER_EXT_DIV,          rl_USER_RES_WAIT,
                rl_USER_WND_LW,         rl_USER_WND_TH,         rl_USER_PNT_TIME,         rl_USER_EXPOSURE,
                rl_USER_EXPOS_DELAY,
                // Hello Registers
		rl_HELLO_DEVICE_TYPE,   rl_HELLO_DEVICE_MOD,    rl_HELLO_DEVICE_SER_LO,   rl_HELLO_DEVICE_SER_HI,
                rl_HELLO_BASE_Z,        rl_HELLO_RANGE_Z,       rl_HELLO_RANGE_XS,        rl_HELLO_RANGE_XE,
                // Factory Registers
		rl_FACTORY_NOISE_LEVEL, rl_FACTORY_AtEXP_LEVEL, rl_FACTORY_EXP_OPT_LEVEL, rl_FACTORY_POWER_OPT,
                rl_FACTORY_AOUT0_MIN,   rl_FACTORY_AOUT0_MAX,   rl_FACTORY_AOUT1_MIN,     rl_FACTORY_AOUT1_MAX,
                rl_FACTORY_AOUT_BASE,   rl_FACTORY_LAS_BEG,     rl_FACTORY_LAS_END,       rl_FACTORY_LAS_MIN,
                rl_FACTORY_LAS_MAX,     rl_FACTORY_LAS_CLK,     rl_FACTORY_LAS_POL
	};
//---------------------------------------------------------------------------
AnsiString str_FACTORY_PARAMETERS_NAME[con_FACTORY_REGISTERS] = {
		// SENSOR
                "SEQUENCER",       "NROF_PIXELS",         "NROF_LINES",           "INT_TIME",
                "X_REG",           "YL_REG",              "YR_REG",               "IMAGE_CORE",
                "AMPFILER",        "DACRAW_REG",          "DACFINE_REG",          "ADC_REG",
		// USER
                "Sensor On/Off",   "Network address",     "UART baudrate",        "Result length",
                "Laser intensity", "External signals",    "External divider",     "Lock time of result",
                "ROI left width",  "ROI top height",      "Point time",           "Exposure",
                "External delay",
                // HELLO
		"Device type",     "Device modification", "Device serial lo",     "Device serial hi",
                "Base distance",   "Measuring range Z",   "Measuring range Xsmr", "Measuring range Xemr",
		// FACTORY
		"NOISE_LEVEL",     "AtEXP_LEVEL",         "EXP_OPT_LEVEL",        "POWER_OPT",
                "AOUT0_MIN",       "AOUT0_MAX",           "AOUT1_MIN",            "AOUT1_MAX",
                "AOUT_BASE",       "LAS_BEG",             "LAS_END",              "LAS_MIN",
                "LAS_MAX",         "LAS_CLK",             "LAS_POL"

        };
//---------------------------------------------------------------------------
AnsiString str_USER_PARAMETERS_NAME[con_USER_REGISTERS] = {
                "Sensor On/Off",   "Network address",  "UART baudrate",    "Result length",
                "Laser intensity", "External signals", "External divider", "Lock time of result",
                "ROI left width",  "ROI top height",   "Point time",       "Exposure",
                "External delay"
        };
//---------------------------------------------------------------------------
TEditStyle es_FACTORY_PARAMETERS[con_FACTORY_REGISTERS] = {
                // SENSOR
                esSimple, esSimple, esSimple, esSimple,
                esSimple, esSimple, esSimple, esSimple,
                esSimple, esSimple, esSimple, esSimple,
                // USER
                esSimple, esSimple, esSimple, esSimple,
                esSimple, esSimple, esSimple, esSimple,
                esSimple, esSimple, esSimple, esSimple,
                esSimple,
                // HELLO
                esSimple, esSimple, esSimple, esSimple,
                esSimple, esSimple, esSimple, esSimple,
                // FACTORY
                esSimple, esSimple, esSimple, esSimple,
                esSimple, esSimple, esSimple, esSimple,
                esSimple, esSimple, esSimple, esSimple,
                esSimple, esSimple, esSimple
        };
//---------------------------------------------------------------------------
TEditStyle es_USER_PARAMETERS[con_USER_REGISTERS] = {
                esPickList, esPickList, esPickList, esPickList,
                esPickList, esEllipsis, esPickList, esPickList,
                esSimple,   esSimple,   esSimple,   esEllipsis,
                esEllipsis
        };
//---------------------------------------------------------------------------
// Constructor TRF620Interface public
__fastcall TRF620Interface::TRF620Interface()
{
        pInterface = new TInterface;
        Polynom = 0xA001;
        pCRC = new TCRC(&Polynom);
}
//---------------------------------------------------------------------------
// Destructor TRF620Interface public
__fastcall TRF620Interface::~TRF620Interface()
{
        delete pCRC;
        delete pInterface;
}
//---------------------------------------------------------------------------
// Get Packet private
RF620INT_STATUS __fastcall TRF620Interface::Get_Packet_Data(LPBYTE lpBuffer, LPWORD lpBytes)
{
        WORD ind_Pack, nBytes, Value;
        *lpBytes = 0;
        INT_Read.pBuffer = lpBuffer;
        INT_Read.nNumberOfBytesToRead = con_RS_MARK_Bytes;
        INT_Read.lpOverlapped = NULL;
        while (1) {
                Status = pInterface->INT_ReadFile(&INT_Read);
                if (Status != RF620INT_OK) return(Status);
                Value = (*lpBuffer) & mask_RS_MARK;
                if (Value == con_RS_MARK) break;
        };
        INT_Read.nNumberOfBytesToRead = con_RS_LEN_Bytes;
        Status = pInterface->INT_ReadFile(&INT_Read);
        if (Status != RF620INT_OK)
                return(Status);
        nBytes = 0;
        for (ind_Pack = 0; ind_Pack < con_RS_LEN_Bytes; ind_Pack ++)
                nBytes |= ((*(lpBuffer + ind_Pack) & mask_RS_DATA) << (7 * ind_Pack));
        INT_Read.nNumberOfBytesToRead = nBytes;
        Status = pInterface->INT_ReadFile(&INT_Read);
        if (Status != RF620INT_OK)
                return(Status);
        INT_Read.pBuffer = &CRC_BUFFER[0];
        INT_Read.nNumberOfBytesToRead = con_RS_CRC_Bytes;
        Status = pInterface->INT_ReadFile(&INT_Read);
        if (Status != RF620INT_OK) return(Status);
        for (ind_Pack = 0; ind_Pack < nBytes; ind_Pack++)
                *(lpBuffer + ind_Pack) &= mask_RS_DATA;
        CRC_Pack = 0;
        pCRC->Update(&CRC_Pack, lpBuffer, nBytes);
        CRC_Pack_RCV = 0;
        for (ind_Pack = 0; ind_Pack < con_RS_CRC_Bytes; ind_Pack++)
                CRC_Pack_RCV |= (CRC_BUFFER[ind_Pack] & mask_RS_DATA) << (7 * ind_Pack);
        if (CRC_Pack_RCV != CRC_Pack) Status = RF620INT_PACKET_ERROR;
        else *lpBytes = nBytes;
        return(Status);
}
//---------------------------------------------------------------------------
RF620INT_STATUS __fastcall TRF620Interface::Get_Packet_BitMap(LPBYTE lpBuffer, LPBYTE lpBuffer_Bitmap, LPWORD lpLeft, LPWORD lpTop, LPWORD lpWidth, LPWORD lpHeight)
{
        WORD ind_Pack, nWidth, nHeight, nLeft, nTop, Value;
        DWORD ind_dwPack;
        *lpWidth = *lpHeight = 0;
        INT_Read.pBuffer = lpBuffer;
        INT_Read.nNumberOfBytesToRead = con_RS_MARK_Bytes;
        INT_Read.lpOverlapped = NULL;
        while (1) {
                Status = pInterface->INT_ReadFile(&INT_Read);
                if (Status != RF620INT_OK) return(Status);
                Value = (*lpBuffer) & mask_RS_MARK;
                if (Value == con_RS_MARK) break;
        };
        INT_Read.nNumberOfBytesToRead = con_RS_LEN_Bytes;
        Status = pInterface->INT_ReadFile(&INT_Read);
        if (Status != RF620INT_OK) return(Status);
        nHeight = 0;
        for (ind_Pack = 0; ind_Pack < con_RS_LEN_Bytes; ind_Pack ++)
                nHeight |= ((*(lpBuffer + ind_Pack) & mask_RS_DATA) << (7 * ind_Pack));
        INT_Read.nNumberOfBytesToRead = con_RS_LEN_Bytes;
        Status = pInterface->INT_ReadFile(&INT_Read);
        if (Status != RF620INT_OK) return(Status);
        nWidth = 0;
        for (ind_Pack = 0; ind_Pack < con_RS_LEN_Bytes; ind_Pack ++) {
                *(lpBuffer + ind_Pack) &= mask_RS_DATA;
                nWidth |= ((*(lpBuffer + ind_Pack) & mask_RS_DATA) << (7 * ind_Pack));
        }
        CRC_Pack = 0;
        pCRC->Update(&CRC_Pack, lpBuffer, con_RS_LEN_Bytes);
        INT_Read.nNumberOfBytesToRead = con_RS_LEN_Bytes;
        Status = pInterface->INT_ReadFile(&INT_Read);
        if (Status != RF620INT_OK) return(Status);
        nTop = 0;
        for (ind_Pack = 0; ind_Pack < con_RS_LEN_Bytes; ind_Pack ++) {
                *(lpBuffer + ind_Pack) &= mask_RS_DATA;
                nTop |= ((*(lpBuffer + ind_Pack) & mask_RS_DATA) << (7 * ind_Pack));
        }
        pCRC->Update(&CRC_Pack, lpBuffer, con_RS_LEN_Bytes);
        INT_Read.nNumberOfBytesToRead = con_RS_LEN_Bytes;
        Status = pInterface->INT_ReadFile(&INT_Read);
        if (Status != RF620INT_OK) return(Status);
        nLeft = 0;
        for (ind_Pack = 0; ind_Pack < con_RS_LEN_Bytes; ind_Pack ++) {
                *(lpBuffer + ind_Pack) &= mask_RS_DATA;
                nLeft |= ((*(lpBuffer + ind_Pack) & mask_RS_DATA) << (7 * ind_Pack));
        }
        pCRC->Update(&CRC_Pack, lpBuffer, con_RS_LEN_Bytes);

        for (ind_Pack = 0; ind_Pack < nHeight; ind_Pack ++) {
                INT_Read.nNumberOfBytesToRead = nWidth;
                INT_Read.pBuffer = (lpBuffer_Bitmap + ind_Pack * nWidth);
                Status = pInterface->INT_ReadFile(&INT_Read);
                if (Status != RF620INT_OK) return(Status);
        }
        INT_Read.pBuffer = &CRC_BUFFER[0];
        INT_Read.nNumberOfBytesToRead = con_RS_CRC_Bytes;
        Status = pInterface->INT_ReadFile(&INT_Read);
        if (Status != RF620INT_OK) return(Status);
        for (ind_dwPack = 0; ind_dwPack < (DWORD)(nWidth * nHeight); ind_dwPack++)
                *(lpBuffer_Bitmap + ind_dwPack) &= mask_RS_DATA;
        pCRC->Update(&CRC_Pack, lpBuffer_Bitmap, nWidth * nHeight);
        CRC_Pack_RCV = 0;
        for (ind_Pack = 0; ind_Pack < con_RS_CRC_Bytes; ind_Pack++)
                CRC_Pack_RCV |= (CRC_BUFFER[ind_Pack] & mask_RS_DATA) << (7 * ind_Pack);
        if (CRC_Pack_RCV != CRC_Pack) Status = RF620INT_PACKET_ERROR;
        else {
                *lpLeft = nLeft;
                *lpTop = nTop;
                *lpWidth = nWidth;
                *lpHeight = nHeight;
        }
        return(Status);
}
//---------------------------------------------------------------------------
// Send Packet private
RF620INT_STATUS __fastcall TRF620Interface::Send_Packet(BYTE RF620Command, LPBYTE lpBuffer, WORD nBytes)
{
        WORD ind_Pack, nPackBytes = con_RS_NODATA_Bytes + nBytes;
        DWORD NWriten;
        LPBYTE lpPackBuffer = new BYTE[nPackBytes];
        CRC_Pack = 0;
        pCRC->Update(&CRC_Pack, &RF620Command, 1);
        pCRC->Update(&CRC_Pack, lpBuffer, nBytes);
        *(lpPackBuffer + con_RS_MARK_POS) = ((Parameters.NET_Address & mask_RS_ADDR) & mask_RS_DATA) | con_RS_MARK;
        for (ind_Pack = 0; ind_Pack < con_RS_LEN_Bytes; ind_Pack ++)
                *(lpPackBuffer + con_RS_LEN_POS + ind_Pack) = ((nBytes >> (7 * ind_Pack)) & mask_RS_DATA) | con_RS_DATA;
        *(lpPackBuffer + con_RS_CMD_POS) = (RF620Command & mask_RS_DATA) | con_RS_DATA;
        for (ind_Pack = 0; ind_Pack < nBytes; ind_Pack ++)
                *(lpPackBuffer + con_RS_DATA_POS + ind_Pack) = (*(lpBuffer + ind_Pack) & mask_RS_DATA) | con_RS_DATA;
        for (ind_Pack = 0; ind_Pack < con_RS_CRC_Bytes; ind_Pack ++)
                *(lpPackBuffer + con_RS_DATA_POS + nBytes + ind_Pack) = ((CRC_Pack >> (7 * ind_Pack)) & mask_RS_DATA) | con_RS_DATA;
        INT_Write.pBuffer = lpPackBuffer;
        INT_Write.nNumberOfBytesToWrite = nPackBytes;
        INT_Write.lpOverlapped = NULL;
        Status = pInterface->INT_WriteFile(&INT_Write);
        delete [] lpPackBuffer;
        return(Status);
}
//---------------------------------------------------------------------------
// Connect To Device
RF620INT_STATUS __fastcall TRF620Interface::Connect(LPRF620INTPARAMETERS pRF620INT_Parameters)
{
        Parameters = *pRF620INT_Parameters;
        INT_Parameters.Mode = Parameters.Mode;
        INT_Parameters.lpszName = Parameters.lpszName;
        INT_Parameters.StopBits = INT_1_STOP_BITS;
        INT_Parameters.Parity = INT_NO_PARITY;
        INT_Parameters.BaudRate = Parameters.BaudRate;
        INT_Parameters.dwFlagsAndAttributes = FILE_ATTRIBUTE_NORMAL;
        INT_Parameters.dwBufferIn = 1024;
        INT_Parameters.dwBufferOut = 1024;
        INT_Parameters.dwTimeOutByte = 100;
        INT_Parameters.dwTimeOutTotal = 1000;
        Status = pInterface->Create(&INT_Parameters);
        return(Status);
}
//---------------------------------------------------------------------------
// Disconnect From Device
RF620INT_STATUS __fastcall TRF620Interface::Disonnect()
{
        Status = pInterface->Close();
        return(Status);
}
//---------------------------------------------------------------------------
RF620INT_STATUS __fastcall TRF620Interface::RF620_Hello(tHELLO_REGs_MAP *lpHELLO_PARAMETERS)
{
        WORD nBytes, ind_Data, count_Data, Value;
        BYTE nBytes_Param, ind_Param;
        Status = Send_Packet(CMD_HELLO, NULL, 0);
        if (Status != RF620INT_OK) return(Status);
        Status = Get_Packet_Data(&BUFFER[0], &nBytes);
        if (Status != RF620INT_OK) return(Status);
        count_Data = 0;
        for (ind_Param = 0; ind_Param < con_HELLO_REGISTERS; ind_Param ++) {
                nBytes_Param = PARAMS_LEN[ra_FACTORY_HELLO + ind_Param];
                count_Data += nBytes_Param;
        }
        if (count_Data == nBytes) {
                count_Data = 0;
                for (ind_Param = 0; ind_Param < con_HELLO_REGISTERS; ind_Param ++) {
                        nBytes_Param = PARAMS_LEN[ra_FACTORY_HELLO + ind_Param];
                        Value = 0;
                        for (ind_Data = 0; ind_Data < nBytes_Param; ind_Data ++)
                                Value |= ((BUFFER[count_Data + ind_Data] & mask_RS_DATA) << (7 * ind_Data));
                        HELLO_PARAMETERS.REG_ADDR[ind_Param] = Value;
                        count_Data += nBytes_Param;
                }
                *lpHELLO_PARAMETERS = HELLO_PARAMETERS;
        } else Status = RF620INT_OTHER_ERROR;
        return(Status);
}
//---------------------------------------------------------------------------
RF620INT_STATUS __fastcall TRF620Interface::RF620_Get_User_Param(BYTE nParameter, LPWORD lpValue)
{
        WORD nBytes, ind_Data, count_Data, Value;
        BYTE nBytes_Param, ind_Param  = nParameter;
        count_Data = 0;
        nParameter += 1;
        if ((nParameter > 0) && (nParameter <= con_USER_REGISTERS)) {
                BUFFER[count_Data] = nParameter;
                count_Data ++;
                Status = Send_Packet(CMD_REQUEST_USER_PARAM, &BUFFER[0], count_Data);
                if (Status != RF620INT_OK) return(Status);
                Status = Get_Packet_Data(&BUFFER[0], &nBytes);
                if (Status != RF620INT_OK) return(Status);
                count_Data = 0;
                nBytes_Param = PARAMS_LEN[ra_FACTORY_USER + ind_Param];
                count_Data += nBytes_Param;
                if (count_Data == nBytes) {
                        nBytes_Param = PARAMS_LEN[ra_FACTORY_USER + ind_Param];
                        Value = 0;
                        count_Data = 0;
                        for (ind_Data = 0; ind_Data < nBytes_Param; ind_Data ++)
                                Value |= ((BUFFER[count_Data + ind_Data] & mask_RS_DATA) << (7 * ind_Data));
                        USER_PARAMETERS.REG_ADDR[ind_Param] = Value;
                        *lpValue = Value;
                } else Status = RF620INT_OTHER_ERROR;
        } else Status = RF620INT_OK;
        return(Status);
}
//---------------------------------------------------------------------------
RF620INT_STATUS __fastcall TRF620Interface::RF620_Set_User_Param(BYTE nParameter, LPWORD lpValue)
{
        WORD nBytes, ind_Data, count_Data, Value;
        DWORD BaudRate;
        BYTE nBytes_Param, ind_Param = nParameter;
        nBytes_Param = PARAMS_LEN[ra_FACTORY_USER + ind_Param];
        Value = *lpValue;
        count_Data = 0;
        nParameter += 1;
        if ((nParameter > 0) && (nParameter <= con_USER_REGISTERS)) {
                BUFFER[count_Data] = nParameter;
                count_Data ++;
                for (ind_Data = 0; ind_Data < nBytes_Param; ind_Data ++)
                        BUFFER[count_Data + ind_Data] = ((Value >> (7 * ind_Data)) & mask_RS_DATA);
                count_Data += nBytes_Param;
                Status = Send_Packet(CMD_RECORD_USER_PARAM, &BUFFER[0], count_Data);
                if (Status != RF620INT_OK) return(Status);
                USER_PARAMETERS.REG_ADDR[ind_Param] = Value;
                if (ind_Param == ra_USER_ADDR) {
                        Parameters.NET_Address = Value;
                        Sleep(1000);
                }
                if (ind_Param == ra_USER_RSBR) {
                        if ((Value & 0x40) == 0x00) BaudRate = 115200 << Value;
                        else BaudRate = 4800 << Value;
                        Sleep(1000);
                        pInterface->INT_SetBaurRate(&BaudRate);
                }
        }
        return(Status);
}
//---------------------------------------------------------------------------
RF620INT_STATUS __fastcall TRF620Interface::RF620_Get_User_Params(tUSER_REGs_MAP *lpUSER_PARAMETERS)
{
        BYTE ind_Param;
        WORD Value;
        for (ind_Param = 0; ind_Param < con_USER_REGISTERS; ind_Param ++) {
                Status = RF620_Get_User_Param(ind_Param, &Value);
                if (Status != RF620INT_OK) return(Status);
                USER_PARAMETERS.REG_ADDR[ind_Param] = Value;
        }
        *lpUSER_PARAMETERS = USER_PARAMETERS;
        return(Status);
}
//---------------------------------------------------------------------------
RF620INT_STATUS __fastcall TRF620Interface::RF620_Set_User_Params(tUSER_REGs_MAP *lpUSER_PARAMETERS)
{
        BYTE ind_Param;
        WORD Value;
        USER_PARAMETERS = *lpUSER_PARAMETERS;
        for (ind_Param = 0; ind_Param < con_USER_REGISTERS; ind_Param ++) {
                Value = USER_PARAMETERS.REG_ADDR[ind_Param];
                Status = RF620_Set_User_Param(ind_Param, &Value);
                if (Status != RF620INT_OK) return(Status);
        }
        return(Status);
}
//---------------------------------------------------------------------------
RF620INT_STATUS __fastcall TRF620Interface::RF620_Save_User_Params(bool bDefault)
{
        WORD nBytes, ind_Data, count_Data, Value, tmpValue;
        count_Data = 0;
        if (bDefault) Value = con_Save_Default;
        else Value = con_Save_Current;
        BUFFER[count_Data] = Value;
        count_Data ++;
        Status = Send_Packet(CMD_SAVE_USER_PARAM, &BUFFER[0], count_Data);
        if (Status != RF620INT_OK) return(Status);
        Status = Get_Packet_Data(&BUFFER[0], &nBytes);
        if (Status != RF620INT_OK) return(Status);
        if (count_Data == nBytes) {
                if (bDefault) {
                        Parameters.NET_Address = 0;
                        DWORD BaudRate = 921600;
                        pInterface->INT_SetBaurRate(&BaudRate);
                }
                tmpValue = 0;
                for (ind_Data = 0; ind_Data < nBytes; ind_Data ++)
                        tmpValue |= ((BUFFER[ind_Data] & mask_RS_DATA) << (7 * ind_Data));
                if (tmpValue != Value) Status = RF620INT_FLASH_ERROR;
        } else Status = RF620INT_OTHER_ERROR;
        return(Status);
}
//---------------------------------------------------------------------------
RF620INT_STATUS __fastcall TRF620Interface::RF620_Get_Line_Result(LPBYTE lpNumPack, LPWORD lpNumPoint, LPWORD lpBuffer)
{
        WORD nPoint, nBytes, ind_Data, ind_WORD, tmpValue;
        Status = Send_Packet(CMD_REQUEST_LINE_RESULT, NULL, 0);
        if (Status != RF620INT_OK) return(Status);
        Status = Get_Packet_Data(&BUFFER[0], &nBytes);
        if (Status != RF620INT_OK) return(Status);
        *lpNumPack = BUFFER[0] & mask_RS_DATA;
        tmpValue = 0;
        for (ind_Data = 0; ind_Data < sizeof(WORD); ind_Data ++)
                tmpValue |= ((BUFFER[ind_Data + 1] & mask_RS_DATA) << (7 * ind_Data));
        *lpNumPoint = nPoint = tmpValue;
        for (ind_WORD = 0; ind_WORD < 2*nPoint; ind_WORD ++) {
                tmpValue = 0;
                for (ind_Data = 0; ind_Data < sizeof(WORD); ind_Data ++)
                        tmpValue |= ((BUFFER[ind_WORD*sizeof(WORD) + ind_Data + 3] & mask_RS_DATA) << (7 * ind_Data));
                *(lpBuffer + ind_WORD) = tmpValue;
        }
        return(Status);
}
//---------------------------------------------------------------------------
RF620INT_STATUS __fastcall TRF620Interface::RF620_Get_BitMap(LPBYTE lpBuffer, LPWORD lpLeft, LPWORD lpTop, LPWORD lpWidth, LPWORD lpHeight)
{
        Status = Send_Packet(CMD_REQUEST_BITMAP, NULL, 0);
        if (Status != RF620INT_OK) return(Status);
        Status = Get_Packet_BitMap(&BUFFER[0], lpBuffer, lpLeft, lpTop, lpWidth, lpHeight);
        return(Status);
}
//---------------------------------------------------------------------------
RF620INT_STATUS __fastcall TRF620Interface::RF620_Rotate_Angle(float *lpfAngle)
{
        WORD nBytes, ind_Data;
        tANGLE_REGs_MAP Angle;
        Status = Send_Packet(CMD_ROTATE_RESULT, NULL, 0);
        if (Status != RF620INT_OK) return(Status);
        Status = Get_Packet_Data(&BUFFER[0], &nBytes);
        if (Status != RF620INT_OK) return(Status);
        Angle.FLOAT_DWORD = 0;
        if (nBytes == 5) {
                for (ind_Data = 0; ind_Data < nBytes; ind_Data ++)
                        Angle.FLOAT_DWORD |= ((BUFFER[ind_Data] & mask_RS_DATA) << (7 * ind_Data));
                *lpfAngle = Angle.REG_VALUE;
        } else Status = RF620INT_OTHER_ERROR;
        return(Status);
}
//---------------------------------------------------------------------------
RF620INT_STATUS __fastcall TRF620Interface::RF620_Get_Angle(float *lpfAngle)
{
        WORD nBytes, ind_Data;
        tANGLE_REGs_MAP Angle;
        Status = Send_Packet(CMD_GET_ANGLE, NULL, 0);
        if (Status != RF620INT_OK) return(Status);
        Status = Get_Packet_Data(&BUFFER[0], &nBytes);
        if (Status != RF620INT_OK) return(Status);
        Angle.FLOAT_DWORD = 0;
        if (nBytes == 5) {
                for (ind_Data = 0; ind_Data < nBytes; ind_Data ++)
                        Angle.FLOAT_DWORD |= ((BUFFER[ind_Data] & mask_RS_DATA) << (7 * ind_Data));
                *lpfAngle = Angle.REG_VALUE;
        } else Status = RF620INT_OTHER_ERROR;
        return(Status);
}
//---------------------------------------------------------------------------
RF620INT_STATUS __fastcall TRF620Interface::RF620_Save_Angle(bool bDefault)
{
        WORD nBytes, ind_Data, count_Data, Value, tmpValue;
        count_Data = 0;
        if (bDefault) Value = con_Save_Default;
        else Value = con_Save_Current;
        BUFFER[count_Data] = Value;
        count_Data ++;
        Status = Send_Packet(CMD_FLASH_ANGLE, &BUFFER[0], count_Data);
        if (Status != RF620INT_OK) return(Status);
        Status = Get_Packet_Data(&BUFFER[0], &nBytes);
        if (Status != RF620INT_OK) return(Status);
        if (count_Data == nBytes) {
                tmpValue = 0;
                for (ind_Data = 0; ind_Data < nBytes; ind_Data ++)
                        tmpValue |= ((BUFFER[ind_Data] & mask_RS_DATA) << (7 * ind_Data));
                if (tmpValue != Value) Status = RF620INT_FLASH_ERROR;
        } else Status = RF620INT_OTHER_ERROR;
        return(Status);
}
//---------------------------------------------------------------------------
RF620INT_STATUS __fastcall TRF620Interface::RF620_Get_Factory_Params(tFACT_REGs_MAP *lpFACTORY_PARAMETERS)
{
        WORD nBytes, ind_Data, count_Data, Value;
        BYTE nBytes_Param, ind_Param;
        Status = Send_Packet(CMD_REQUEST_FACTORY_PARAMS, NULL, 0);
        if (Status != RF620INT_OK) return(Status);
        Status = Get_Packet_Data(&BUFFER[0], &nBytes);
        if (Status != RF620INT_OK) return(Status);
        count_Data = 0;
        for (ind_Param = 0; ind_Param < con_FACTORY_REGISTERS; ind_Param ++) {
                nBytes_Param = PARAMS_LEN[ind_Param];
                count_Data += nBytes_Param;
        }
        if (count_Data == nBytes) {
                count_Data = 0;
                for (ind_Param = 0; ind_Param < con_FACTORY_REGISTERS; ind_Param ++) {
                        nBytes_Param = PARAMS_LEN[ind_Param];
                        Value = 0;
                        for (ind_Data = 0; ind_Data < nBytes_Param; ind_Data ++)
                                Value |= ((BUFFER[count_Data + ind_Data] & mask_RS_DATA) << (7 * ind_Data));
                        FACTORY_PARAMETERS.REG_ADDR[ind_Param] = Value;
                        count_Data += nBytes_Param;
                }
                *lpFACTORY_PARAMETERS = FACTORY_PARAMETERS;
        } else Status = RF620INT_OTHER_ERROR;
        return(Status);
}
//---------------------------------------------------------------------------
RF620INT_STATUS __fastcall TRF620Interface::RF620_Set_Factory_Params(tFACT_REGs_MAP *lpFACTORY_PARAMETERS)
{
        WORD nBytes, ind_Data, count_Data, Value;
        BYTE nBytes_Param, ind_Param;
        FACTORY_PARAMETERS = *lpFACTORY_PARAMETERS;
        count_Data = 0;
        for (ind_Param = 0; ind_Param < con_FACTORY_REGISTERS; ind_Param ++) {
                nBytes_Param = PARAMS_LEN[ind_Param];
                Value = FACTORY_PARAMETERS.REG_ADDR[ind_Param];
                for (ind_Data = 0; ind_Data < nBytes_Param; ind_Data ++)
                        BUFFER[count_Data + ind_Data] = (Value >> (7 * ind_Data)) & mask_RS_DATA;
                count_Data += nBytes_Param;
        }
        Status = Send_Packet(CMD_RECORD_FACTORY_PARAMS, &BUFFER[0], count_Data);
        if (Status != RF620INT_OK) return(Status);
        return(Status);
}
//---------------------------------------------------------------------------
RF620INT_STATUS __fastcall TRF620Interface::RF620_Save_Factory_Params(bool bDefault)
{
        WORD nBytes, ind_Data, count_Data, Value, tmpValue;
        count_Data = 0;
        if (bDefault) Value = con_Save_Default;
        else Value = con_Save_Current;
        BUFFER[count_Data] = Value;
        count_Data ++;
        Status = Send_Packet(CMD_SAVE_FACTORY_PARAMS, &BUFFER[0], count_Data);
        if (Status != RF620INT_OK) return(Status);
        Status = Get_Packet_Data(&BUFFER[0], &nBytes);
        if (Status != RF620INT_OK) return(Status);
        if (count_Data == nBytes) {
                tmpValue = 0;
                for (ind_Data = 0; ind_Data < nBytes; ind_Data ++)
                        tmpValue |= ((BUFFER[ind_Data] & mask_RS_DATA) << (7 * ind_Data));
                if (tmpValue != Value) Status = RF620INT_FLASH_ERROR;
        } else Status = RF620INT_OTHER_ERROR;
        return(Status);
}
//---------------------------------------------------------------------------
RF620INT_STATUS __fastcall TRF620Interface::RF620_Set_Factory_Tables(short int *lpTables, DWORD TableLength)
{
        WORD ind_Pack, nPack, nPackMod, count_Data, ind_Data;
        WORD ind_Byte, nWordDiv, nWordMod, Value, nBytes;
        DWORD data_ADDR;
        nWordDiv = 4096;
        nPack = TableLength / nWordDiv;
        nWordMod = TableLength % nWordDiv;
        data_ADDR = 0;
        for (ind_Pack = 0; ind_Pack < nPack; ind_Pack ++) {
                count_Data = 0;
                for (ind_Byte = 0; ind_Byte < con_TBL_ADR_Bytes; ind_Byte ++)
                        BUFFER[count_Data + ind_Byte] = (data_ADDR >> (7 * ind_Byte)) & mask_RS_DATA;
                count_Data += con_TBL_ADR_Bytes;
                for (ind_Byte = 0; ind_Byte < con_TBL_LEN_Bytes; ind_Byte ++)
                        BUFFER[count_Data + ind_Byte] = (nWordDiv >> (7 * ind_Byte)) & mask_RS_DATA;
                count_Data += con_TBL_LEN_Bytes;
                for (ind_Data = 0; ind_Data < nWordDiv; ind_Data ++) {
                        Value = *(lpTables + ind_Pack * nWordDiv + ind_Data);
                        for (ind_Byte = 0; ind_Byte < con_TBL_LEN_Bytes; ind_Byte ++)
                                BUFFER[count_Data + ind_Byte] = (Value >> (7 * ind_Byte)) & mask_RS_DATA;
                        count_Data += con_TBL_LEN_Bytes;

                }
                Status = Send_Packet(CMD_RECORD_TABLE_XZ, &BUFFER[0], count_Data);
                if (Status != RF620INT_OK) return(Status);
                Status = Get_Packet_Data(&BUFFER[0], &nBytes);
                if (Status != RF620INT_OK) return(Status);
                Value = BUFFER[0] & mask_RS_DATA;
                if (Value != 0) Status = RF620INT_OTHER_ERROR;
                if (Status != RF620INT_OK) return(Status);
                data_ADDR += nWordDiv;
        }
        if (nWordMod) {
                count_Data = 0;
                for (ind_Byte = 0; ind_Byte < con_TBL_ADR_Bytes; ind_Byte ++)
                        BUFFER[count_Data + ind_Byte] = (data_ADDR >> (7 * ind_Byte)) & mask_RS_DATA;
                count_Data += con_TBL_ADR_Bytes;
                for (ind_Byte = 0; ind_Byte < con_TBL_LEN_Bytes; ind_Byte ++)
                        BUFFER[count_Data + ind_Byte] = (nWordMod >> (7 * ind_Byte)) & mask_RS_DATA;
                count_Data += con_TBL_LEN_Bytes;
                for (ind_Data = 0; ind_Data < nWordMod; ind_Data ++) {
                        Value = *(lpTables + ind_Pack * nWordDiv + ind_Data);
                        for (ind_Byte = 0; ind_Byte < con_TBL_LEN_Bytes; ind_Byte ++)
                                BUFFER[count_Data + ind_Byte] = (Value >> (7 * ind_Byte)) & mask_RS_DATA;
                        count_Data += con_TBL_LEN_Bytes;

                }
                Status = Send_Packet(CMD_RECORD_TABLE_XZ, &BUFFER[0], count_Data);
                if (Status != RF620INT_OK) return(Status);
                Status = Get_Packet_Data(&BUFFER[0], &nBytes);
                if (Status != RF620INT_OK) return(Status);
                Value = BUFFER[0] & mask_RS_DATA;
                if (Value != 0) Status = RF620INT_OTHER_ERROR;
                if (Status != RF620INT_OK) return(Status);
        }
        return (Status);
}
//---------------------------------------------------------------------------
RF620INT_STATUS __fastcall TRF620Interface::RF620_Save_Factory_Tables()
{
        WORD nBytes, ind_Data, count_Data, Value, tmpValue;
        count_Data = 0;
        Value = con_Save_Current;
        BUFFER[count_Data] = Value;
        count_Data ++;
        Status = Send_Packet(CMD_SAVE_TABLE_XZ, &BUFFER[0], 1);
        if (Status != RF620INT_OK) return(Status);
        Sleep(40000);
        Status = Get_Packet_Data(&BUFFER[0], &nBytes);
        if (Status != RF620INT_OK) return(Status);
        if (count_Data == nBytes) {
                tmpValue = 0;
                for (ind_Data = 0; ind_Data < nBytes; ind_Data ++)
                        tmpValue |= ((BUFFER[ind_Data] & mask_RS_DATA) << (7 * ind_Data));
                if (tmpValue != con_Save_Default) Status = RF620INT_FLASH_ERROR;
        } else Status = RF620INT_OTHER_ERROR;
        return(Status);
}
//---------------------------------------------------------------------------
RF620INT_STATUS __fastcall TRF620Interface::RF620_Get_NO_Line_Result(LPWORD lpBuffer)
{
        WORD nBytes, ind_Data, ind_WORD, tmpValue;
        Status = Send_Packet(CMD_REQUEST_NO_LINE_RESULT, NULL, 0);
        if (Status != RF620INT_OK) return(Status);
        Status = Get_Packet_Data(&BUFFER[0], &nBytes);
        if (Status != RF620INT_OK) return(Status);
        for (ind_WORD = 0; ind_WORD < (WORD)(nBytes/sizeof(WORD)); ind_WORD ++) {
                tmpValue = 0;
                for (ind_Data = 0; ind_Data < sizeof(WORD); ind_Data ++)
                        tmpValue |= ((BUFFER[ind_WORD*sizeof(WORD) + ind_Data] & mask_RS_DATA) << (7 * ind_Data));
                *(lpBuffer + ind_WORD) = tmpValue;
        }
        return(Status);
}
//---------------------------------------------------------------------------
