//---------------------------------------------------------------------------
#ifndef _RF620InterfaceH_
        #define _RF620InterfaceH_
        #include <Grids.hpp>
        #include "Interface.h"
        #include "CRC.h"
//---------------------------------------------------------------------------
        #ifndef _RF620Interface_types_
                #define _RF620Interface_types_
                #define con_cNET_ADDR           31
                #define con_cLas_Int            31
                #define con_cExt_Div            16383
                #define con_cLock_Time          16383
                #define con_cWnd_Beg            90
                #define con_cWnd_Len0           10
                #define con_cWnd_Len1           100
                #define con_cPxl_Time           1023                
                #define con_RS_MARK             0x00
                #define mask_RS_MARK            0x80
        	#define con_RS_DATA         	0x80
        	#define mask_RS_DATA		0x7F
        	#define con_RS_FORONE		0x20
	        #define mask_RS_ADDR		0x1F

                #define con_RS_MARK_POS         0x00
	        #define con_RS_MARK_Bytes	0x01
	        #define con_RS_LEN_POS  	(con_RS_MARK_Bytes)
	        #define con_RS_LEN_Bytes	0x02
                #define con_RS_CMD_POS          (con_RS_MARK_Bytes + con_RS_LEN_Bytes)
	        #define con_RS_CMD_Bytes	0x01
                #define con_RS_DATA_POS         (con_RS_MARK_Bytes + con_RS_LEN_Bytes + con_RS_CMD_Bytes)
        	#define con_RS_CRC_Bytes	0x03
                #define con_RS_NODATA_Bytes     (con_RS_MARK_Bytes + con_RS_LEN_Bytes + con_RS_CMD_Bytes + con_RS_CRC_Bytes)

	        #define con_Save_Default	0x0033
        	#define con_Save_Current	0x0055
                #define con_TBL_Width           640
                #define con_TBL_Height          512
                #define con_TBL_ADR_Bytes	0x04
        	#define con_TBL_LEN_Bytes	0x02
                #define con_BMP_Width           640
                #define con_BMP_Height          512
                typedef ULONG RF620INT_STATUS;
                typedef BYTE RF620Command;
                typedef LPBYTE lpRF620Command;
                typedef struct _RF620INTPARAMETERS {
                        INT_MODE Mode;
                        LPCTSTR lpszName;
                        DWORD BaudRate;
                        BYTE NET_Address;
                } RF620INTPARAMETERS, *LPRF620INTPARAMETERS;
//---------------------------------------------------------------------------
	        // SENSOR Registers
        	#define rl_SENSOR_SEQUENCER		2
	        #define rl_SENSOR_NROF_PIXELS		2
        	#define rl_SENSOR_NROF_LINES		2
	        #define rl_SENSOR_INT_TIME		2
        	#define rl_SENSOR_X_REG			2
	        #define rl_SENSOR_YL_REG		2
        	#define rl_SENSOR_YR_REG		2
	        #define rl_SENSOR_IMAGE_CORE		2
        	#define rl_SENSOR_AMPFILER		2
	        #define rl_SENSOR_DACRAW_REG		2
        	#define rl_SENSOR_DACFINE_REG		2
	        #define rl_SENSOR_ADC_REG		2

        	#define ra_SENSOR_SEQUENCER		0
	        #define ra_SENSOR_NROF_PIXELS		(ra_SENSOR_SEQUENCER + 1)
        	#define ra_SENSOR_NROF_LINES		(ra_SENSOR_NROF_PIXELS + 1)
	        #define ra_SENSOR_INT_TIME		(ra_SENSOR_NROF_LINES + 1)
        	#define ra_SENSOR_X_REG			(ra_SENSOR_INT_TIME + 1)
	        #define ra_SENSOR_YL_REG		(ra_SENSOR_X_REG + 1)
        	#define ra_SENSOR_YR_REG		(ra_SENSOR_YL_REG + 1)
	        #define ra_SENSOR_IMAGE_CORE		(ra_SENSOR_YR_REG + 1)
        	#define ra_SENSOR_AMPFILER		(ra_SENSOR_IMAGE_CORE + 1)
	        #define ra_SENSOR_DACRAW_REG		(ra_SENSOR_AMPFILER + 1)
        	#define ra_SENSOR_DACFINE_REG		(ra_SENSOR_DACRAW_REG + 1)
	        #define ra_SENSOR_ADC_REG		(ra_SENSOR_DACFINE_REG + 1)
        	#define con_SENSOR_REGISTERS		(ra_SENSOR_ADC_REG + 1)


	        // HELLO Registers
        	#define rl_HELLO_DEVICE_TYPE		2
	        #define rl_HELLO_DEVICE_MOD		1
        	#define rl_HELLO_DEVICE_SER_LO		2
        	#define rl_HELLO_DEVICE_SER_HI		2
	        #define rl_HELLO_BASE_Z			2
        	#define rl_HELLO_RANGE_Z		2
	        #define rl_HELLO_RANGE_XS		2
        	#define rl_HELLO_RANGE_XE		2

	        #define ra_HELLO_DEVICE_TYPE		0
        	#define ra_HELLO_DEVICE_MOD		(ra_HELLO_DEVICE_TYPE + 1)
	        #define ra_HELLO_DEVICE_SER_LO		(ra_HELLO_DEVICE_MOD + 1)
        	#define ra_HELLO_DEVICE_SER_HI		(ra_HELLO_DEVICE_SER_LO + 1)
	        #define ra_HELLO_BASE_Z			(ra_HELLO_DEVICE_SER_HI + 1)
        	#define ra_HELLO_RANGE_Z		(ra_HELLO_BASE_Z + 1)
	        #define ra_HELLO_RANGE_XS		(ra_HELLO_RANGE_Z + 1)
        	#define ra_HELLO_RANGE_XE		(ra_HELLO_RANGE_XS + 1)
	        #define con_HELLO_REGISTERS		(ra_HELLO_RANGE_XE + 1)

        	// USER Registrs
	        #define rl_USER_POWER			1
        	#define rl_USER_ADDR			1
	        #define rl_USER_RSBR			1
        	#define rl_USER_RES_LEN			1
	        #define rl_USER_LAS_INT			1
        	#define rl_USER_EXT_PORT		1
	        #define rl_USER_EXT_DIV			2
        	#define rl_USER_RES_WAIT		2
	        #define rl_USER_WND_LW			2
        	#define rl_USER_WND_TH			2
	        #define rl_USER_PNT_TIME		2
        	#define rl_USER_EXPOSURE		2
                #define rl_USER_EXPOS_DELAY		2

	        #define ra_USER_POWER			0
        	#define ra_USER_ADDR			(ra_USER_POWER + 1)
	        #define ra_USER_RSBR			(ra_USER_ADDR + 1)
        	#define ra_USER_RES_LEN			(ra_USER_RSBR + 1)
	        #define ra_USER_LAS_INT			(ra_USER_RES_LEN + 1)
        	#define ra_USER_EXT_PORT		(ra_USER_LAS_INT + 1)
	        #define ra_USER_EXT_DIV			(ra_USER_EXT_PORT + 1)
        	#define ra_USER_RES_WAIT		(ra_USER_EXT_DIV + 1)
	        #define ra_USER_WND_LW			(ra_USER_RES_WAIT + 1)
        	#define ra_USER_WND_TH			(ra_USER_WND_LW + 1)
	        #define ra_USER_PNT_TIME		(ra_USER_WND_TH + 1)
        	#define ra_USER_EXPOSURE		(ra_USER_PNT_TIME + 1)
                #define ra_USER_EXPOS_DELAY		(ra_USER_EXPOSURE + 1)
	        #define con_USER_REGISTERS		(ra_USER_EXPOS_DELAY + 1)

        	// FACTORY Registrs
        	#define rl_FACTORY_SENSOR		con_SENSOR_REGISTERS
	        #define rl_FACTORY_USER			con_USER_REGISTERS
        	#define rl_FACTORY_HELLO		con_HELLO_REGISTERS
	        #define rl_FACTORY_LASER		con_LASER_REGs
	        #define rl_FACTORY_NOISE_LEVEL		2
        	#define rl_FACTORY_AtEXP_LEVEL		2
	        #define rl_FACTORY_EXP_OPT_LEVEL	2
        	#define rl_FACTORY_POWER_OPT		2
        	#define rl_FACTORY_AOUT0_MIN		2
	        #define rl_FACTORY_AOUT0_MAX		2
        	#define rl_FACTORY_AOUT1_MIN		2
	        #define rl_FACTORY_AOUT1_MAX		2
        	#define rl_FACTORY_AOUT_BASE		2
	        #define rl_FACTORY_LAS_BEG		2
        	#define rl_FACTORY_LAS_END		2
	        #define rl_FACTORY_LAS_MIN		2
        	#define rl_FACTORY_LAS_MAX		2
	        #define rl_FACTORY_LAS_CLK		2
        	#define rl_FACTORY_LAS_POL		1


	        #define ra_FACTORY_SENSOR		0
        	#define ra_FACTORY_USER			(ra_FACTORY_SENSOR + rl_FACTORY_SENSOR)
	        #define ra_FACTORY_HELLO		(ra_FACTORY_USER + rl_FACTORY_USER)
        	#define ra_FACTORY_NOISE_LEVEL		(ra_FACTORY_HELLO + rl_FACTORY_HELLO)
	        #define ra_FACTORY_AtEXP_LEVEL		(ra_FACTORY_NOISE_LEVEL + 1)
        	#define ra_FACTORY_EXP_OPT_LEVEL	(ra_FACTORY_AtEXP_LEVEL + 1)
        	#define ra_FACTORY_POWER_OPT	        (ra_FACTORY_EXP_OPT_LEVEL + 1)
	        #define ra_FACTORY_AOUT0_MIN		(ra_FACTORY_POWER_OPT + 1)
        	#define ra_FACTORY_AOUT0_MAX		(ra_FACTORY_AOUT0_MIN + 1)
	        #define ra_FACTORY_AOUT1_MIN		(ra_FACTORY_AOUT0_MAX + 1)
        	#define ra_FACTORY_AOUT1_MAX		(ra_FACTORY_AOUT1_MIN + 1)
	        #define ra_FACTORY_AOUT_BASE		(ra_FACTORY_AOUT1_MAX + 1)
        	#define ra_FACTORY_LAS_BEG		(ra_FACTORY_AOUT_BASE + 1)
	        #define ra_FACTORY_LAS_END		(ra_FACTORY_LAS_BEG + 1)
        	#define ra_FACTORY_LAS_MIN		(ra_FACTORY_LAS_END + 1)
        	#define ra_FACTORY_LAS_MAX		(ra_FACTORY_LAS_MIN + 1)
                #define ra_FACTORY_LAS_CLK              (ra_FACTORY_LAS_MAX + 1)
        	#define ra_FACTORY_LAS_POL		(ra_FACTORY_LAS_CLK + 1)
	        #define con_FACTORY_REGISTERS		(ra_FACTORY_LAS_POL + 1)
//---------------------------------------------------------------------------
        	// SENSOR Registers Type
	        typedef union {
                        WORD 	REG_ADDR[con_SENSOR_REGISTERS];
                        struct {
                                union {
   	                        	WORD 	REG_VALUE;
			                struct {
				                WORD 	SHUTTER_TYPE	:1,
                                                        FRAME_CAL_MODE	:1,
	        					LINE_CAL_MODE	:1,
		        				CONT_CHARGE     :1,
			        			GRAN_X_SEQ	:2,
				        		GRAN_SS_SEQ	:2,
					        	KNEEPOINT	:2,
						        KNEEPOINT_EN	:1,
        						VDDR_RIGHT_EXT	:1;
	        			} BITs;
   	                        } SEQUENCER;
			        WORD 	NROF_PIXELS,
                                        NROF_LINES,
        				INT_TIME,
	        			X_REG,
		        		YL_REG,
			        	YR_REG;
           	                union {
   	                	        WORD 	REG_VALUE;
		        		struct {
			        		WORD 	TEST		:2,
				                        X_SUB		:1,
					        	X_SWAP		:2,
						        Y_SUB		:1,
        						Y_SWAP		:2;
	        			} BITs;
   	                        } IMAGE_CORE;
			        WORD	AMPFILER,
        			        DACRAW_REG,
	        			DACFINE_REG,
		        		ADC_REG;
        		} REG_NAME;
	        } tSENSOR_REGs_MAP;
	        // USER Registrs Type
	        typedef union {
		        WORD 	REG_ADDR[con_USER_REGISTERS];
                    	struct {
    		                union {
                        		WORD 	REG_VALUE;
				        struct {
					        WORD 	ON_OFF          :1;
        				} BITs;
	        		} POWER;
		        	WORD 	NETWORK_ADDRESS;
			        union {
                    			WORD 	REG_VALUE;
		        		struct {
			        		WORD 	BAUDRATE	:2,
							UNUSED		:4,
							LOWSPEED	:1;
				        } BITs;
			        } RS_BAUDRATE;
        			WORD	RESULT_LENGTH,
					LASER_INTECITY;
                    		union {
        	                	WORD 	REG_VALUE;
				        struct {
					        WORD 	OUT_PRIORITY	:1,
							STROBE_ACTIV	:1,
							EXTERNAL_SINC	:1;
        				} BITs;
	        		} EXTERNAL_PORTS;
		        	WORD 	EXTERNAL_DIVIDER,
					RESULT_WAIT;
			        union {
                                        WORD	REG_VALUE;
                                        struct {
                                                WORD	LEFT		:7,
			        		        WIDTH           :7;
			                } BITs;
			        } WINDOW_LW;
			        union {
			                WORD	REG_VALUE;
			                struct {
			                        WORD	TOP		:7,
			        		        HEIGHT          :7;
			                } BITs;
                                } WINDOW_TH;
			        WORD	POINT_TIME;
                                union {
                                        WORD	REG_VALUE;
                                        struct {
					        WORD	AUTO	        :1,
        					        VALUE	        :13;
                                        } BITs;
		                } EXPOSURE;
                                WORD    EXPOSURE_DELAY;
                        } REG_NAME;
                } tUSER_REGs_MAP;
                // HELLO Registrs Type
	        typedef union {
                        WORD 	REG_ADDR[con_HELLO_REGISTERS];
                        struct {
                                WORD			DEVICE_TYPE,
                                                        DEVICE_MODIFICATION,
                                                        DEVICE_SERIAL_LO,
                                                        DEVICE_SERIAL_HI,
                                                        BASE_Z,
                                                        RANGE_Z,
                                                        RANGE_XS,
                                                        RANGE_XE;
        		} REG_NAME;
	        } tHELLO_REGs_MAP;
        	// FACTORY Registrs Type
	        typedef union {
        	        WORD 	REG_ADDR[con_FACTORY_REGISTERS];
	        	struct {
			        tSENSOR_REGs_MAP	SENSOR_REGs;
			        tUSER_REGs_MAP		USER_REGs;
			        tHELLO_REGs_MAP         HELLO_REGs;
				WORD			PULSE_NOISE_LEVEL,
							AUTO_EXP_LEVEL,
							EXP_OPT_VALUE,
							POWER_OPT_VALUE,
							AOUT0_MIN_VALUE,
							AOUT0_MAX_VALUE,
							AOUT1_MIN_VALUE,
							AOUT1_MAX_VALUE,
							AOUT_BASE_VALUE,
							LAS_BEG_VALUE,
							LAS_END_VALUE,
							LAS_MIN_VALUE,
							LAS_MAX_VALUE,
							LAS_CLK_VALUE,
							LAS_POL_VALUE;
		        } REG_NAME;
	        } tFACT_REGs_MAP;
                // ANGLE Registrs Type
        	typedef union {
	        	float REG_VALUE;
		        DWORD FLOAT_DWORD;
        	} tANGLE_REGs_MAP;
                // Commmands
        	enum {
                	// USER Command
		        CMD_HELLO = 0x01,
        		CMD_REQUEST_USER_PARAM,
	        	CMD_RECORD_USER_PARAM,
		        CMD_SAVE_USER_PARAM,
        		CMD_REQUEST_LINE_RESULT,
	        	CMD_REQUEST_BITMAP,
		        CMD_START_RESULT_FLOW,
        		CMD_STOP_RESULT_FLOW,
	        	CMD_FIXED_RESULT,
        		CMD_ROTATE_RESULT,
        		CMD_GET_ANGLE,
	        	CMD_FLASH_ANGLE,
	                // FACTORY Command
		        CMD_REQUEST_FACTORY_PARAMS = 0x20,
        		CMD_RECORD_FACTORY_PARAMS,
	        	CMD_SAVE_FACTORY_PARAMS,
        		CMD_RECORD_TABLE_XZ,
	        	CMD_SAVE_TABLE_XZ,
        		CMD_REQUEST_NO_LINE_RESULT,
                        CMD_SET_DACs
        	};
                enum {
                        RF620INT_OK,
                        RF620INT_PORT_NOT_FOUND,
                        RF620INT_PORT_NOT_OPENNED,
                        RF620INT_READ_TIMEOUT,
                        RF620INT_READ_ERROR,
                        RF620INT_WRITE_TIMEOUT,
                        RF620INT_WRITE_ERROR,
                        RF620INT_OTHER_ERROR,
                        RF620INT_PACKET_ERROR,
                        RF620INT_NOT_CONNECTED,
                        RF620INT_FLASH_ERROR
                };
        #endif
//---------------------------------------------------------------------------
        class TRF620Interface {
                private:
                        WORD Polynom;
                        WORD CRC_Pack, CRC_Pack_RCV;

                        BYTE BUFFER[16384];
                        BYTE CRC_BUFFER[con_RS_CRC_Bytes];

                        TCRC *pCRC;
                        TInterface *pInterface;

                        RF620INT_STATUS Status;
                        RF620INTPARAMETERS Parameters;
                        INTPARAMETERS INT_Parameters;
                        INTWRITE INT_Write;
                        INTREAD INT_Read;
                        tHELLO_REGs_MAP HELLO_PARAMETERS;
                        tFACT_REGs_MAP FACTORY_PARAMETERS;
                        tUSER_REGs_MAP  USER_PARAMETERS;
                        RF620INT_STATUS __fastcall Get_Packet_Data(LPBYTE lpBuffer, LPWORD lpnBytes);
                        RF620INT_STATUS __fastcall Get_Packet_BitMap(LPBYTE lpBuffer, LPBYTE lpBuffer_Bitmap, LPWORD lpLeft, LPWORD lpTop, LPWORD lpWidth, LPWORD lpHeight);
                        RF620INT_STATUS __fastcall Send_Packet(BYTE RF620Command, LPBYTE lpBuffer, WORD nBytes);
                public:
                        __fastcall TRF620Interface();
                        __fastcall ~TRF620Interface();
                        RF620INT_STATUS __fastcall Connect(LPRF620INTPARAMETERS pRF620INT_Parameters);
                        RF620INT_STATUS __fastcall Disonnect();
                        // User
                        RF620INT_STATUS __fastcall RF620_Hello(tHELLO_REGs_MAP *lpHELLO_PARAMETERS);
                        RF620INT_STATUS __fastcall RF620_Get_User_Param(BYTE nParameter, LPWORD lpValue);
                        RF620INT_STATUS __fastcall RF620_Set_User_Param(BYTE nParameter, LPWORD lpValue);
                        RF620INT_STATUS __fastcall RF620_Get_User_Params(tUSER_REGs_MAP *lpUSER_PARAMETERS);
                        RF620INT_STATUS __fastcall RF620_Set_User_Params(tUSER_REGs_MAP *lpUSER_PARAMETERS);
                        RF620INT_STATUS __fastcall RF620_Save_User_Params(bool bDefault);
                        RF620INT_STATUS __fastcall RF620_Get_Line_Result(LPBYTE lpNumPack, LPWORD lpNumPoint, LPWORD lpBuffer);
                        RF620INT_STATUS __fastcall RF620_Get_BitMap(LPBYTE lpBuffer, LPWORD lpLeft, LPWORD lpTop, LPWORD lpWidth, LPWORD lpHeight);
                        RF620INT_STATUS __fastcall RF620_Rotate_Angle(float *lpfAngle);
                        RF620INT_STATUS __fastcall RF620_Get_Angle(float *lpfAngle);
                        RF620INT_STATUS __fastcall RF620_Save_Angle(bool bDefault);
                        // Factory
                        RF620INT_STATUS __fastcall RF620_Get_Factory_Params(tFACT_REGs_MAP *lpFACTORY_PARAMETERS);
                        RF620INT_STATUS __fastcall RF620_Set_Factory_Params(tFACT_REGs_MAP *lpFACTORY_PARAMETERS);
                        RF620INT_STATUS __fastcall RF620_Save_Factory_Params(bool bDefault);
                        RF620INT_STATUS __fastcall RF620_Set_Factory_Tables(short int *lpTables, DWORD TableLength);
                        RF620INT_STATUS __fastcall RF620_Save_Factory_Tables();
                        RF620INT_STATUS __fastcall RF620_Get_NO_Line_Result(LPWORD lpBuffer);
        };
        extern AnsiString str_FACTORY_PARAMETERS_NAME[];
        extern AnsiString str_USER_PARAMETERS_NAME[];
        extern TEditStyle es_FACTORY_PARAMETERS[];        
        extern TEditStyle es_USER_PARAMETERS[];
//---------------------------------------------------------------------------
#endif
